/* @creaBD_Piezas.sql */
SET ECHO ON

/* Crear las tablas y alguna vista, a modo de ejemplo
*/
CREATE TABLE Pieza      (
  clvPieza  NUMBER(9) PRIMARY KEY,
  nombPieza CHAR(32) NOT NULL,
  color     CHAR(32));

CREATE TABLE Proveedor  (
  clvProv  NUMBER(9) PRIMARY KEY,
  nombProv CHAR(32) NOT NULL);

CREATE TABLE suministrar (
  clvProv  NUMBER(9),
  clvPieza NUMBER(9),
  PRIMARY KEY (clvProv, clvPieza),
  FOREIGN KEY (clvProv)  REFERENCES Proveedor(clvProv),
  FOREIGN KEY (clvPieza) REFERENCES Pieza(clvPieza) ON DELETE cascade);

CREATE VIEW infoSuministros AS
  SELECT nombProv, nombPieza
  FROM   Proveedor V, suministrar S, Pieza P
  WHERE  V.clvProv = S.clvProv AND S.clvPieza = P.clvPieza;

/* mostrar la informacin bsica de las tablas y vistas
*/
@infoBD_Piezas.sql
